// color mixer
//
// example na michani barev se svetlem
//

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <io.h>
#include "Directx.h"
#include "Tga.h"
#include "Main.h"

#define APPNAME "Colour Mixer"
#define WNDNAME "Xample na mixhani barev"
static int Width = 320;
static int Height = 200;

static BMP *spot, *screen;

unsigned __int32 *video;
unsigned __int32 *buffer;

static int have_to_screenshot;
// pokud je 1, ma se udelat screenshot

int	Save_TrueColor_BMP(char *filename, BMP *bmp)
{
	unsigned long ByteCount;
	BITMAPFILEHEADER bmfh;
	BITMAPINFOHEADER bmih;
	unsigned char *lpbBuf;
	unsigned __int32 bBuf;
	unsigned int BuffLen;
	int i, j, x;
	FILE *BMPfp;

	BuffLen = ((3 * bmp->width + 3) >> 2) << 2;
	lpbBuf =  (unsigned char*) malloc(BuffLen);
	// compute lenght of line-buffer

	if((BMPfp = fopen(filename, "wb")) == NULL)
		return 0;
	// opens file

	bmfh.bfType = ('B'|('M'<<8)); // "BM"
	bmfh.bfSize = 0;              // necessary to modify
	bmfh.bfReserved1 = 0;
	bmfh.bfReserved2 = 0;
	bmfh.bfOffBits = sizeof(BITMAPFILEHEADER) +
		sizeof(BITMAPINFOHEADER);
	bmih.biSize = sizeof(BITMAPINFOHEADER);
	bmih.biWidth = bmp->width;
	bmih.biHeight = bmp->height;
	bmih.biPlanes = 1;
	bmih.biBitCount = 24;	      // True Color
	bmih.biCompression = BI_RGB;
	bmih.biSizeImage = 0;         // necessary to modify
	bmih.biXPelsPerMeter = 96;
	bmih.biYPelsPerMeter = 96;
	bmih.biClrUsed = 0;
	bmih.biClrImportant = 0;
	// create header

	fwrite(&bmfh, sizeof(BITMAPFILEHEADER), 1, BMPfp);
	fwrite(&bmih, sizeof(BITMAPINFOHEADER), 1, BMPfp);
	// writing header

	ByteCount = 0;
	for(i = bmp->height - 1; i >= 0; i --) {
		for(j = 0, x = 0; j < bmp->width; j ++, x ++) {
			bBuf = bmp->bytes[i * bmp->width + j];
			lpbBuf[x * 3] = (char)((bBuf >> 16) & 0xff);
			lpbBuf[x * 3 + 1] = (char)((bBuf >> 8) & 0xff);
			lpbBuf[x * 3 + 2] = (char)(bBuf & 0xff);
			// saved in BGR, not RGB
			ByteCount += 3;
		}

		if(fwrite(lpbBuf, 1, BuffLen, BMPfp) != BuffLen) {
			free(lpbBuf);
			return 0;
		}
	}

	// repair header
	bmih.biSizeImage = ByteCount;
	bmfh.bfSize = sizeof(BITMAPFILEHEADER) +
	   ByteCount + sizeof(BITMAPINFOHEADER);
	fseek(BMPfp, 0, SEEK_SET);
	fwrite(&bmfh, sizeof(BITMAPFILEHEADER), 1, BMPfp);
	fwrite(&bmih, sizeof(BITMAPINFOHEADER), 1, BMPfp);

	fclose(BMPfp);

	free(lpbBuf);

	return 1;
}

void Make_ScreenShot(unsigned __int32 *scr)
{
	char str[256];
	BMP screen;
	int i;

	i = 0;
	do
		sprintf(str, "Screenshot%2x.bmp", i ++);
	while(_access(str, 0) != -1);
	// hleda index screenshotu ktery neexistuje
	// _access() je v <io.h>

	screen.width = Width;
	screen.height = Height;
	screen.bytes = scr;
	// vytvori bitmapu

	Save_TrueColor_BMP(str, &screen);
	// .. a ulozi ji
}

// main
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdline, int nCmdShow)
{
	static char szAppName[] = APPNAME;
	HWND		hwnd;
	MSG			msg;
	WNDCLASSEX	wndclass;
	int i;

	wndclass.cbSize			= sizeof (wndclass);
	wndclass.style			= CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc	= Wokno;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;
	wndclass.hInstance		= hInstance;
	wndclass.hIcon			= LoadIcon(hInstance, IDI_APPLICATION);
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= (HBRUSH) GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName	= 0;
	wndclass.lpszClassName	= szAppName;
	wndclass.hIconSm		= LoadIcon(NULL, IDI_APPLICATION);

	RegisterClassEx(&wndclass);

	hwnd = CreateWindow(szAppName,
		WNDNAME, WS_DLGFRAME,
		CW_USEDEFAULT, CW_USEDEFAULT,
		Width, Height, NULL,
		NULL, hInstance, NULL);

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);
	ShowCursor(FALSE);

	InitDirectX(hwnd, Width, Height);
	// inicializovano okno

	if((buffer = (unsigned __int32*) malloc(Width * Height * 4)) == NULL)
		return 0;

	if((spot = Load_TGA("spot.tga")) == NULL)
		return 0;
	if((screen = Load_TGA("scr.tga")) == NULL)
		return 0;

	SetTimer(hwnd, 0, 20, NULL);

	SetCursorPos(Width >> 1, Height >> 1);
	// pripravi Mouse

	while (GetMessage (&msg, NULL, 0, 0)) {
		TranslateMessage (&msg);
		DispatchMessage (&msg);
	}

	free((void*)buffer);
	// uvolnuje pamet

	free((void*)spot->bytes);
	free((void*)spot);
	free((void*)screen->bytes);
	free((void*)screen);
	// uvolnuje bitmapy

	return msg.wParam;
}

void Draw_Spot(int x, int y)
{
	int bx, by, bw, bh;
	int x0;

	x -= spot->width / 2;
	y -= spot->height / 2;
	// x, y maji ukazovat prostredek bitmapy

	bw = spot->width;
	bh = spot->height;
	//

	x0 = x;
	for(by = 0; by < bh; by ++, y ++) {
		for(bx = 0, x = x0; bx < bw; bx ++, x ++) {
			if(x >= 0 && x < Width && y >= 0 && y < Height)
				buffer[x + Width * y] = spot->bytes[bx + spot->width * by];
		}
	}
	// normalne kopiruje bitmapu, kontroluje hranice obrazovky
}

LRESULT CALLBACK Wokno (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	int r, g, b;
	POINT p;
	int i;

	switch (iMsg) {
		case WM_KEYDOWN :
			if(wParam == 27){
				ShowCursor(TRUE);
				SendMessage(hwnd, WM_CLOSE, 0, 0);

				return 0;
			} else if(wParam == VK_F12) {
				have_to_screenshot = 1;
			}
			return 0;

		case WM_TIMER :
			GetCursorPos(&p);
			// osetri mouse

			memset(buffer, 0, 4 * Width * Height);
			// nastavi buffer na prazdny

			Draw_Spot(p.x, p.y);
			// nakresli do bufferu spot (svetlo) - normalne zkopiruje bitmapu,
			// jen je potreba zkontrolovat aby "nevylezla z obrazu"

			for(i = 0; i < Width * Height; i ++) {
				/*r = (buffer[i] & 0xff0000) >> 16;
				g = (buffer[i] & 0x00ff00) >>  8;
				b = (buffer[i] & 0x0000ff);
				// rgb v bufferu (to je vlastne alpha kanal = svetlost)

				r *= (screen->bytes[i] & 0xff0000) >> 16;
				g *= (screen->bytes[i] & 0x00ff00) >>  8;
				b *= (screen->bytes[i] & 0x0000ff);
				// se vynasobi rgb obrazku

				r >>= 8;
				g >>= 8;
				b >>= 8;
				// vydeli se 256 .. a je hotovo.

				buffer[i] = (r & 0xff) + ((g << 8) & 0xff00) + ((b << 16) & 0xff0000);
				// barvy se daji zpatky, ale kvuli directx se prohodi RGB->BGR*/

				
				// no a takhle se to da napsat "zhustene" :
				r = ((buffer[i] >> 16) * (screen->bytes[i] >> 16)) & 0xff00;
				g = (((buffer[i] >> 8) & 0xff) * ((screen->bytes[i] >> 8) & 0xff)) & 0xff00;
				b = ((buffer[i] & 0xff) * (screen->bytes[i] & 0xff)) & 0xff00;

				buffer[i] = (r + (g << 8) + (b << 16)) >> 8;
			}

			if(InitVideoBuffer(&video)) {
				///
				memcpy(video, buffer, 4 * Width * Height);
				/// zkopruje obraz
			
				FlipVideoBuffer();
			}

			if(have_to_screenshot) {
				for(i = 0; i < Width * Height; i ++) {
					buffer[i] = (buffer[i] & 0x00ff00) |
						       ((buffer[i] >> 16) & 0xff) |
							   ((buffer[i] & 0xff) << 16);
				}
				// prohodi R a B, G zustava na stejnem miste
				Make_ScreenShot(buffer);
				have_to_screenshot = 0;
			}
			// udela screenshot (je potreba prevest RGB->BGR)

			return 0;

		case WM_DESTROY :
			TerminateDirectX();
			PostQuitMessage (0);
			return 0;
	}
	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
}





